package pusher

import (
	"sync"

	"github.com/cloudwego/kitex/client"
	dns "github.com/kitex-contrib/resolver-dns"
)

var (
	defaultClient     RPCClient
	defaultDstService = "pusher"
	defaultClientOpts = []client.Option{
		client.WithResolver(dns.NewDNSResolver()),
	}
	once sync.Once
)

func init() {
	DefaultClient()
}

func DefaultClient() RPCClient {
	once.Do(func() {
		defaultClient = newClient(defaultDstService, defaultClientOpts...)
	})
	return defaultClient
}

func newClient(dstService string, opts ...client.Option) RPCClient {
	c, err := NewRPCClient(dstService, opts...)
	if err != nil {
		panic("failed to init client: " + err.Error())
	}
	return c
}

func InitClient(dstService string, opts ...client.Option) {
	defaultClient = newClient(dstService, opts...)
}
